package com.sqx.modules.message.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.sqx.common.utils.PageUtils;
import com.sqx.common.utils.Query;
import com.sqx.common.utils.Result;
import com.sqx.modules.app.entity.UserEntity;
import com.sqx.modules.app.service.UserService;
import com.sqx.modules.interviewRecord.entity.InterviewRecord;
import com.sqx.modules.message.dao.MessageInfoDao;
import com.sqx.modules.message.entity.MessageInfo;
import com.sqx.modules.message.service.MessageService;
import com.sqx.modules.resumes.service.CompanyService;
import com.sqx.modules.sendRecord.entity.SendRecord;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * 消息
 */
@Service
public class MessageServiceImpl extends
        ServiceImpl<MessageInfoDao, MessageInfo> implements MessageService {

    @Autowired
    private MessageInfoDao messageInfoDao;
    @Autowired
    private UserService userService;
    @Autowired
    private CompanyService companyService;

    @Override
    public Result auditMessage(Long messageId, Integer status, String auditContent) {
        MessageInfo messageInfo = baseMapper.selectById(messageId);
        messageInfo.setStatus(status);
        UserEntity byId = userService.getById(messageInfo.getByUserId());
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        if (status == 2) {
            if (byId.getStatus().equals(1)) {

                //2封号
                byId.setStatus(2);
                userService.updateById(byId);

                MessageInfo messageInfos = new MessageInfo();
                messageInfos.setContent("当前账号存在违规行为，已被系统封禁，如有疑问，请联系客服！");
                messageInfos.setTitle("账号封禁通知");
                messageInfos.setState(String.valueOf(4));
                messageInfos.setUserName(byId.getUserName());
                messageInfos.setUserId(String.valueOf(byId.getUserId()));
                messageInfos.setCreateAt(sdf.format(new Date()));
                messageInfos.setIsSee("0");
                baseMapper.insert(messageInfos);
            }

        } else if (status == 3) {
            //3下架
            if (messageInfo.getPlatform() == 3) {

            } else if (messageInfo.getPlatform() == 4) {

            }
        }
        messageInfo.setAuditContent(auditContent);
        baseMapper.updateById(messageInfo);
        return Result.success();
    }

    @Override
    public PageUtils selectMessageByUserIdLimit1(Long userId) {
        Page<SendRecord> pages = new Page<>();
        pages.setSize(-1);
        return new PageUtils(baseMapper.selectMessageByUserIdLimit1(pages, userId));

    }

    @Override
    public IPage<MessageInfo> selectComplaintByType(Integer page, Integer limit, MessageInfo messageInfo) {
        Page<MessageInfo> pages;
        if (page != null && limit != null) {
            pages = new Page<>(page, limit);
        } else {
            pages = new Page<>();
            pages.setSize(-1);
        }
        return baseMapper.selectComplaintByType(pages, messageInfo);

    }

    @Override
    public PageUtils selectMessageList(Map<String, Object> params) {
        Long userId = (Long) params.get("userId");
        Integer state = (Integer) params.get("state");
        Integer type = (Integer) params.get("type");
        Integer platformId = (Integer) params.get("platformId");


        IPage<MessageInfo> page = this.page(
                new Query<MessageInfo>().getPage(params),
                new QueryWrapper<MessageInfo>()
                        .eq(userId != null, "user_id", userId)
                        .eq(state != null, "state", state)
                        .eq(platformId != null, "platform_id", platformId)
                        .eq(type != null, "type", type).ne("state", 3).orderByDesc("create_at")
        );


        List<MessageInfo> records = page.getRecords();
        if (!records.isEmpty()) {
            for (MessageInfo messageInfo : records) {
                if ("3".equals(messageInfo.getState())) {
                    messageInfo.setCompany(companyService.getById(messageInfo.getByUserId()));
                }
                if (messageInfo.getUserId() != null) {
                    UserEntity user = userService.getById(messageInfo.getUserId());
                    if (user != null) {
                        messageInfo.setUserName(user.getUserName());
                    }
                }
                if (messageInfo.getByUserId() != null) {
                    UserEntity user = userService.getById(messageInfo.getByUserId());
                    if (user != null) {
                        messageInfo.setByUserName(user.getUserName());
                    }
                }
                if (("8".equals(messageInfo.getState()))) {
                    messageInfo.setUserEntity(userService.getById(messageInfo.getUserId()));
                }
            }

        }

        return new PageUtils(page);
    }

    @Override
    public int saveBody(MessageInfo messageInfo) {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        Date now = new Date();
        messageInfo.setCreateAt(sdf.format(now));
        messageInfo.setStatus(0);
        return messageInfoDao.insert(messageInfo);
    }

    @Override
    public int update(MessageInfo messageInfo) {
        return messageInfoDao.updateById(messageInfo);
    }

    @Override
    public int delete(Long id) {
        return messageInfoDao.deleteById(id);
    }

    @Override
    public MessageInfo selectMessageById(Long id) {
        return messageInfoDao.selectById(id);
    }

    @Override
    public int updateSendState(Long userId, Integer state) {
        return messageInfoDao.updateSendState(userId, state);
    }


}
